Index: branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/trcdta.F90
===================================================================
--- branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 7383)
+++ branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 7391)
@@ -9,5 +9,5 @@
    !!            3.4   !  2010-11  (C. Ethe, G. Madec)  use of fldread + dynamical allocation 
    !!            3.5   !  2013-08  (M. Vichi)  generalization for other BGC models
-   !!            3.6   !  2015-03  (T. Lovato) revision of code log info
+   !!            3.6   !  2015-03  (T. Lovato) revisit code I/O
    !!----------------------------------------------------------------------
 #if defined key_top 
@@ -28,5 +28,5 @@
 
    PUBLIC   trc_dta         ! called in trcini.F90 and trcdmp.F90
-   PUBLIC   trc_dta_init    ! called in trcini.F90 
+   PUBLIC   trc_dta_ini     ! called in trcini.F90 
 
    INTEGER  , SAVE, PUBLIC                             :: nb_trcdta   ! number of tracers to be initialised with data
@@ -45,7 +45,7 @@
 CONTAINS
 
-   SUBROUTINE trc_dta_init(ntrc)
-      !!----------------------------------------------------------------------
-      !!                   ***  ROUTINE trc_dta_init  ***
+   SUBROUTINE trc_dta_ini(ntrc)
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE trc_dta_ini  ***
       !!                    
       !! ** Purpose :   initialisation of passive tracer input data 
@@ -70,9 +70,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('trc_dta_init')
+      IF( nn_timing == 1 )  CALL timing_start('trc_dta_ini')
       !
       IF( lwp ) THEN
          WRITE(numout,*) ' '
-         WRITE(numout,*) '  trc_dta_init : Tracers Initial Conditions (IC)'
+         WRITE(numout,*) '  trc_dta_ini : Tracers Initial Conditions (IC)'
          WRITE(numout,*) '  ~~~~~~~~~~~ '
       ENDIF
@@ -83,5 +83,5 @@
       ALLOCATE( n_trc_index(ntrc), slf_i(ntrc), STAT=ierr0 )
       IF( ierr0 > 0 ) THEN
-         CALL ctl_stop( 'trc_dta_init: unable to allocate n_trc_index' )   ;   RETURN
+         CALL ctl_stop( 'trc_dta_ini: unable to allocate n_trc_index' )   ;   RETURN
       ENDIF
       nb_trcdta      = 0
@@ -103,9 +103,9 @@
       REWIND( numnat_ref )              ! Namelist namtrc_dta in reference namelist : Passive tracer input data
       READ  ( numnat_ref, namtrc_dta, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_dta_init in reference namelist', lwp )
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_dta_ini in reference namelist', lwp )
 
       REWIND( numnat_cfg )              ! Namelist namtrc_dta in configuration namelist : Passive tracer input data
       READ  ( numnat_cfg, namtrc_dta, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_dta_init in configuration namelist', lwp )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_dta_ini in configuration namelist', lwp )
       IF(lwm) WRITE ( numont, namtrc_dta )
 
@@ -118,5 +118,5 @@
                zfact  = rn_trfac(jn)
                IF( clndta /=  clntrc ) THEN 
-                  CALL ctl_warn( 'trc_dta_init: passive tracer data initialisation    ',   &
+                  CALL ctl_warn( 'trc_dta_ini: passive tracer data initialisation    ',   &
                   &              'Input name of data file : '//TRIM(clndta)//   &
                   &              ' differs from that of tracer : '//TRIM(clntrc)//' ')
@@ -132,5 +132,5 @@
          ALLOCATE( sf_trcdta(nb_trcdta), rf_trfac(nb_trcdta), STAT=ierr1 )
          IF( ierr1 > 0 ) THEN
-            CALL ctl_stop( 'trc_dta_init: unable to allocate  sf_trcdta structure' )   ;   RETURN
+            CALL ctl_stop( 'trc_dta_ini: unable to allocate  sf_trcdta structure' )   ;   RETURN
          ENDIF
          !
@@ -143,5 +143,5 @@
                IF( sn_trcdta(jn)%ln_tint )  ALLOCATE( sf_trcdta(jl)%fdta(jpi,jpj,jpk,2) , STAT=ierr3 )
                IF( ierr2 + ierr3 > 0 ) THEN
-                 CALL ctl_stop( 'trc_dta_init : unable to allocate passive tracer data arrays' )   ;   RETURN
+                 CALL ctl_stop( 'trc_dta_ini : unable to allocate passive tracer data arrays' )   ;   RETURN
                ENDIF
             ENDIF
@@ -149,15 +149,15 @@
          ENDDO
          !                         ! fill sf_trcdta with slf_i and control print
-         CALL fld_fill( sf_trcdta, slf_i, cn_dir, 'trc_dta_init', 'Passive tracer data', 'namtrc' )
+         CALL fld_fill( sf_trcdta, slf_i, cn_dir, 'trc_dta_ini', 'Passive tracer data', 'namtrc' )
          !
       ENDIF
       !
       DEALLOCATE( slf_i )          ! deallocate local field structure
-      IF( nn_timing == 1 )  CALL timing_stop('trc_dta_init')
-      !
-   END SUBROUTINE trc_dta_init
-
-
-   SUBROUTINE trc_dta( kt, sf_trcdta, ptrfac, ptrc)
+      IF( nn_timing == 1 )  CALL timing_stop('trc_dta_ini')
+      !
+   END SUBROUTINE trc_dta_ini
+
+
+   SUBROUTINE trc_dta( kt, sf_trcdta, ztrcfac, ztrcdta)
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE trc_dta  ***
@@ -169,15 +169,14 @@
       !!              - ln_trcdmp=F: deallocates the data structure as they are not used
       !!
-      !! ** Action  :   sf_trcdta   passive tracer data on medl mesh and interpolated at time-step kt
-      !!----------------------------------------------------------------------
-      INTEGER                     , INTENT(in   ) ::   kt     ! ocean time-step
-      TYPE(FLD), DIMENSION(1)     , INTENT(inout) ::   sf_trcdta     ! array of information on the field to read
-      REAL(wp)                    , INTENT(in   ) ::   ptrfac  ! multiplication factor
-      REAL(wp), DIMENSION(jpi,jpj,jpk), OPTIONAL  , INTENT(out  ) ::   ptrc
+      !! ** Action  :   sf_trcdta   passive tracer data on meld mesh and interpolated at time-step kt
+      !!----------------------------------------------------------------------
+      INTEGER                          , INTENT(in   )   ::   kt         ! ocean time-step
+      TYPE(FLD), DIMENSION(1)          , INTENT(inout)   ::   sf_trcdta  ! array of information on the field to read
+      REAL(wp)                         , INTENT(in   )   ::   ztrcfac    ! multiplication factor
+      REAL(wp),  DIMENSION(jpi,jpj,jpk), INTENT(inout  ) ::   ztrcdta    ! 3D data array
       !
       INTEGER ::   ji, jj, jk, jl, jkk, ik    ! dummy loop indices
       REAL(wp)::   zl, zi
       REAL(wp), DIMENSION(jpk) ::  ztp                ! 1D workspace
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  ztrcdta   ! 3D  workspace
       CHARACTER(len=100) :: clndta
       !!----------------------------------------------------------------------
@@ -187,10 +186,9 @@
       IF( nb_trcdta > 0 ) THEN
          !
-         CALL wrk_alloc( jpi, jpj, jpk, ztrcdta )    ! Memory allocation
-         !
-         CALL fld_read( kt, 1, sf_trcdta )      !==   read data at kt time step   ==!
-         ztrcdta(:,:,:) = sf_trcdta(1)%fnow(:,:,:) * tmask(:,:,:)    ! Mask
-         !
-         IF( ln_sco ) THEN                   !==   s- or mixed s-zps-coordinate   ==!
+         ! read data at kt time step
+         CALL fld_read( kt, 1, sf_trcdta )
+         ztrcdta(:,:,:) = sf_trcdta(1)%fnow(:,:,:) * tmask(:,:,:)
+         ! 
+         IF( ln_sco ) THEN                !== s- or mixed s-zps-coordinate  ==!
             !
             IF( kt == nit000 .AND. lwp )THEN
@@ -205,11 +203,10 @@
                         ztp(jk) = ztrcdta(ji,jj,1)
                      ELSEIF( zl > gdept_1d(jpk) ) THEN         ! below the last level of data
-                        ztp(jk) =  ztrcdta(ji,jj,jpkm1)
+                        ztp(jk) = ztrcdta(ji,jj,jpkm1)
                      ELSE                                      ! inbetween : vertical interpolation between jkk & jkk+1
                         DO jkk = 1, jpkm1                                  ! when  gdept(jkk) < zl < gdept(jkk+1)
                            IF( (zl-gdept_1d(jkk)) * (zl-gdept_1d(jkk+1)) <= 0._wp ) THEN
                               zi = ( zl - gdept_1d(jkk) ) / (gdept_1d(jkk+1)-gdept_1d(jkk))
-                              ztp(jk) = ztrcdta(ji,jj,jkk) + ( ztrcdta(ji,jj,jkk+1) - &
-                                        ztrcdta(ji,jj,jkk) ) * zi 
+                              ztp(jk) = ztrcdta(ji,jj,jkk) + ( ztrcdta(ji,jj,jkk+1) - ztrcdta(ji,jj,jkk) ) * zi
                            ENDIF
                         END DO
@@ -217,5 +214,5 @@
                   END DO
                   DO jk = 1, jpkm1
-                    ztrcdta(ji,jj,jk) = ztp(jk) * tmask(ji,jj,jk)     ! mask required for mixed zps-s-coord
+                     ztrcdta(ji,jj,jk) = ztp(jk) * tmask(ji,jj,jk)     ! mask required for mixed zps-s-coord
                   END DO
                   ztrcdta(ji,jj,jpk) = 0._wp
@@ -224,6 +221,6 @@
             ! 
          ELSE                                !==   z- or zps- coordinate   ==!
-            !
-            IF( ln_zps ) THEN                      ! zps-coordinate (partial steps) interpolation at the last ocean level
+            ! zps-coordinate (partial steps) interpolation at the last ocean level
+            IF( ln_zps ) THEN
                DO jj = 1, jpj
                   DO ji = 1, jpi
@@ -244,14 +241,6 @@
          ENDIF
          !
-         ! Add multiplicative factor
-         ztrcdta(:,:,:) = ztrcdta(:,:,:) * ptrfac
-         !
-         ! Data structure for trc_ini (and BFMv5.1 coupling)
-         IF( .NOT. PRESENT(ptrc) ) sf_trcdta(1)%fnow(:,:,:) = ztrcdta(:,:,:)
-         !
-         ! Data structure for trc_dmp
-         IF( PRESENT(ptrc) )  ptrc(:,:,:) = ztrcdta(:,:,:)
-         !
-         CALL wrk_dealloc( jpi, jpj, jpk, ztrcdta )
+         ! Scale by multiplicative factor
+         ztrcdta(:,:,:) = ztrcdta(:,:,:) * ztrcfac
          !
       ENDIF
@@ -266,5 +255,5 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE trc_dta( kt, sf_trcdta, ptrfac, ptrc)        ! Empty routine
+   SUBROUTINE trc_dta( kt, sf_trcdta, ztrcfac, ztrcdta)        ! Empty routine
       WRITE(*,*) 'trc_dta: You should not have seen this print! error?', kt
    END SUBROUTINE trc_dta
Index: branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/trcice.F90
===================================================================
--- branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/trcice.F90	(revision 7383)
+++ branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/trcice.F90	(revision 7391)
@@ -17,5 +17,6 @@
    USE trcice_cfc      ! CFC      initialisation
    USE trcice_pisces   ! PISCES   initialisation
-   USE trcice_c14b     ! C14 bomb initialisation
+   USE trcice_c14      ! C14 bomb initialisation
+   USE trcice_age      ! aGE initialisation
    USE trcice_my_trc   ! MY_TRC   initialisation
    
@@ -45,5 +46,6 @@
 
       IF( nn_timing == 1 )  CALL timing_start('trc_ice_ini')
-
+      !
+      CALL trc_nam_ice
       !
       trc_i(:,:,:) = 0.0d0 ! by default
@@ -51,8 +53,9 @@
 
       IF ( nn_ice_tr == 1 ) THEN
-         IF( lk_pisces  )    CALL trc_ice_ini_pisces       ! PISCES  bio-model
-         IF( lk_cfc     )    CALL trc_ice_ini_cfc          ! CFC     tracers
-         IF( lk_c14b    )    CALL trc_ice_ini_c14b         ! C14 bomb  tracer
-         IF( lk_my_trc  )    CALL trc_ice_ini_my_trc       ! MY_TRC  tracers
+         IF( ln_pisces  )    CALL trc_ice_ini_pisces       ! PISCES  bio-model
+         IF( ll_cfc     )    CALL trc_ice_ini_cfc          ! CFC     tracers
+         IF( ln_c14     )    CALL trc_ice_ini_c14          ! C14     tracer
+         IF( ln_age     )    CALL trc_ice_ini_age          ! AGE     tracer
+         IF( ln_my_trc  )    CALL trc_ice_ini_my_trc       ! MY_TRC  tracers
       ENDIF
 
@@ -60,4 +63,55 @@
       !
    END SUBROUTINE trc_ice_ini
+
+   SUBROUTINE trc_nam_ice
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_nam_ice ***
+      !!
+      !! ** Purpose :   Read the namelist for the ice effect on tracers
+      !!
+      !! ** Method  : -
+      !!
+      !!---------------------------------------------------------------------
+      INTEGER :: jn      ! dummy loop indices
+      INTEGER :: ios, ierr     ! Local integer output status for namelist read
+      !
+      TYPE(TRC_I_NML), DIMENSION(jpmaxtrc) :: sn_tri_tracer
+      !!
+      NAMELIST/namtrc_ice/ nn_ice_tr, sn_tri_tracer
+      !!---------------------------------------------------------------------
+      !
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'trc_nam_ice : Read the namelist for trc_ice'
+         WRITE(numout,*) '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
+      ENDIF
+
+      IF( nn_timing == 1 )  CALL timing_start('trc_nam_ice')
+
+      !
+      REWIND( numnat_ref )              ! Namelist namtrc_ice in reference namelist : Passive tracer input data
+      READ  ( numnat_ref, namtrc_ice, IOSTAT = ios, ERR = 901)
+ 901  IF( ios /= 0 ) CALL ctl_nam ( ios , ' namtrc_ice in reference namelist ', lwp )
+
+      REWIND( numnat_cfg )              ! Namelist namtrc_ice in configuration namelist : Pisces external sources of nutrients
+      READ  ( numnat_cfg, namtrc_ice, IOSTAT = ios, ERR = 902 )
+ 902  IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_ice in configuration namelist', lwp )
+
+      IF( lwp ) THEN
+         WRITE(numout,*) ' '
+         WRITE(numout,*) ' Sea ice tracers option (nn_ice_tr) : ', nn_ice_tr
+         WRITE(numout,*) ' '
+      ENDIF
+      !
+      ! Assign namelist stuff
+      DO jn = 1, jptra
+         trc_ice_ratio (jn) = sn_tri_tracer(jn)%trc_ratio
+         trc_ice_prescr(jn) = sn_tri_tracer(jn)%trc_prescr
+         cn_trc_o      (jn) = sn_tri_tracer(jn)%ctrc_o
+      END DO
+
+      IF( nn_timing == 1 )   CALL timing_stop('trc_nam_ice')
+      !
+   END SUBROUTINE trc_nam_ice
 
 #else
@@ -68,4 +122,8 @@
    SUBROUTINE trc_ice_ini                   ! Dummy routine   
    END SUBROUTINE trc_ice_ini
+
+   SUBROUTINE trc_nam_ice
+   END SUBROUTINE trc_nam_ice
+
 #endif
 
Index: branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 7383)
+++ branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 7391)
@@ -24,7 +24,6 @@
    USE trcrst
    USE lib_mpp         ! distribued memory computing library
-   USE sbc_oce
    USE trcice          ! tracers in sea ice
-   USE trcbc,   only : trc_bc_init ! generalized Boundary Conditions
+   USE trcbc,   only : trc_bc_ini ! generalized Boundary Conditions
  
    IMPLICIT NONE
@@ -58,32 +57,25 @@
       IF(lwp) WRITE(numout,*) 'trc_init : initial set up of the passive tracers'
       IF(lwp) WRITE(numout,*) '~~~~~~~'
-
-      !
+      !
+      CALL trc_ini_ctl   ! control 
+      CALL trc_nam       ! read passive tracers namelists
       CALL top_alloc()   ! allocate TOP arrays
       !
-      CALL trc_ini_ctl   ! control 
-      !
-      CALL trc_nam       ! read passive tracers namelists
+      IF(.NOT.ln_trcdta )   ln_trc_ini(:) = .FALSE.
       !
       IF(lwp) WRITE(numout,*)
-      !
       IF( ln_rsttr .AND. .NOT. lk_offline ) CALL trc_rst_cal( nit000, 'READ' )   ! calendar
-      !
       IF(lwp) WRITE(numout,*)
       !
       CALL trc_ini_sms   ! SMS
-      !
+      CALL trc_ini_inv   ! Inventories
       CALL trc_ini_trp   ! passive tracers transport
-      !
       CALL trc_ice_ini   ! Tracers in sea ice
       !
-      IF( lwp )  &
-         &  CALL ctl_opn( numstr, 'tracer.stat', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp , narea )
+      IF(lwp) CALL ctl_opn( numstr, 'tracer.stat', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp , narea )
       !
       CALL trc_ini_state  !  passive tracers initialisation : from a restart or from clim
-      !
-      IF( nn_dttrc /= 1 )        CALL trc_sub_ini      ! Initialize variables for substepping passive tracers
-      !
-      CALL trc_ini_inv   ! Inventories
+      IF( nn_dttrc /= 1 ) &
+      CALL trc_sub_ini    ! Initialize variables for substepping passive tracers
       !
       IF( nn_timing == 1 )   CALL timing_stop('trc_init')
@@ -120,5 +112,4 @@
          cvol(:,:,jk) = e1e2t(:,:) * e3t_n(:,:,jk) * tmask(:,:,jk)
       END DO
-      IF( lk_degrad )   cvol(:,:,:) = cvol(:,:,:) * facvol(:,:,:)    ! degrad option: reduction by facvol
       !                                                              ! total volume of the ocean 
       areatot = glob_sum( cvol(:,:,:) )
@@ -131,8 +122,7 @@
       IF(lwp) THEN               ! control print
          WRITE(numout,*)
-         WRITE(numout,*)
-         WRITE(numout,*) '          *** Total number of passive tracer jptra = ', jptra
-         WRITE(numout,*) '          *** Total volume of ocean                = ', areatot
-         WRITE(numout,*) '          *** Total inital content of all tracers '
+         WRITE(numout,*) '  *** Total number of passive tracer jptra = ', jptra
+         WRITE(numout,*) '  *** Total volume of ocean                = ', areatot
+         WRITE(numout,*) '  *** Total inital content of all tracers '
          WRITE(numout,*)
          DO jn = 1, jptra
@@ -148,5 +138,5 @@
          CALL prt_ctl_trc( tab4d=trn, mask=tmask, clinfo=ctrcnm )
       ENDIF
-9000  FORMAT(' tracer nb : ',i2,'      name :',a10,'      initial content :',e18.10)
+9000  FORMAT('  tracer nb : ',i2,'      name :',a10,'      initial content :',e18.10)
       !
    END SUBROUTINE trc_ini_inv
@@ -158,13 +148,40 @@
       !! ** Purpose :   SMS initialisation
       !!----------------------------------------------------------------------
-      USE trcini_cfc      ! CFC      initialisation
-      USE trcini_pisces   ! PISCES   initialisation
-      USE trcini_c14b     ! C14 bomb initialisation
-      USE trcini_my_trc   ! MY_TRC   initialisation
-      !!----------------------------------------------------------------------
-      IF( lk_pisces  )       CALL trc_ini_pisces       ! PISCES  bio-model
-      IF( lk_cfc     )       CALL trc_ini_cfc          ! CFC     tracers
-      IF( lk_c14b    )       CALL trc_ini_c14b         ! C14 bomb  tracer
-      IF( lk_my_trc  )       CALL trc_ini_my_trc       ! MY_TRC  tracers
+      USE trcini_pisces  ! PISCES   initialisation
+      USE trcini_cfc     ! CFC      initialisation
+      USE trcini_c14     ! C14  initialisation
+      USE trcini_age     ! age initialisation
+      USE trcini_my_trc  ! MY_TRC   initialisation
+      !
+      INTEGER :: jn
+      !!----------------------------------------------------------------------
+      !
+      ! Pass sn_tracer fields to specialized arrays 
+      DO jn = 1, jp_bgc
+         ctrcnm    (jn) = TRIM( sn_tracer(jn)%clsname )
+         ctrcln    (jn) = TRIM( sn_tracer(jn)%cllname )
+         ctrcun    (jn) = TRIM( sn_tracer(jn)%clunit  )
+         ln_trc_ini(jn) =       sn_tracer(jn)%llinit
+         ln_trc_sbc(jn) =       sn_tracer(jn)%llsbc
+         ln_trc_cbc(jn) =       sn_tracer(jn)%llcbc
+         ln_trc_obc(jn) =       sn_tracer(jn)%llobc
+      END DO
+      !    
+      IF( ln_pisces  )   CALL trc_ini_pisces     !  PISCES model
+      IF( ln_my_trc  )   CALL trc_ini_my_trc     !  MY_TRC model
+      IF( ll_cfc     )   CALL trc_ini_cfc        !  CFC's
+      IF( ln_c14     )   CALL trc_ini_c14        !  C14 model
+      IF( ln_age     )   CALL trc_ini_age        !  AGE
+      !
+      IF(lwp) THEN                   ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) ' trc_init: Summary for selected passive tracers'
+         WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+         WRITE(numout,*) ' ID     NAME     INI  SBC  CBC  OBC'
+         DO jn = 1, jptra
+            WRITE(numout,9001) jn, TRIM(ctrcnm(jn)), ln_trc_ini(jn), ln_trc_sbc(jn),ln_trc_cbc(jn),ln_trc_obc(jn)
+         END DO
+      ENDIF
+9001  FORMAT(1x,i3,1x,a10,3x,l2,3x,l2,3x,l2,3x,l2)
       !
    END SUBROUTINE trc_ini_sms
@@ -207,8 +224,8 @@
       !
       ! Initialisation of tracers Initial Conditions
-      IF( ln_trcdta )      CALL trc_dta_init(jptra)
+      IF( ln_trcdta )      CALL trc_dta_ini(jptra)
 
       ! Initialisation of tracers Boundary Conditions
-      IF( lk_my_trc )     CALL trc_bc_init(jptra)
+      IF( ln_my_trc )     CALL trc_bc_ini(jptra)
 
       IF( ln_rsttr ) THEN
@@ -217,17 +234,16 @@
         !
       ELSE
-        !
-        IF( ln_trcdta .AND. nb_trcdta > 0 ) THEN  ! Initialisation of tracer from a file that may also be used for damping
-            !
+        ! Initialisation of tracer from a file that may also be used for damping
+        IF( ln_trcdta .AND. nb_trcdta > 0 ) THEN
+            ! update passive tracers arrays with input data read from file
             DO jn = 1, jptra
-               IF( ln_trc_ini(jn) ) THEN      ! update passive tracers arrays with input data read from file
+               IF( ln_trc_ini(jn) ) THEN
                   jl = n_trc_index(jn) 
-                  CALL trc_dta( nit000, sf_trcdta(jl), rf_trfac(jl) )   ! read tracer data at nit000
-                  trn(:,:,:,jn) = sf_trcdta(jl)%fnow(:,:,:) 
+                  CALL trc_dta( nit000, sf_trcdta(jl), rf_trfac(jl), trn(:,:,:,jn) )
                   !
-                  IF( .NOT.ln_trcdmp .AND. .NOT.ln_trcdmp_clo ) THEN      !== deallocate data structure   ==!
-                     !                                                    (data used only for initialisation)
+                  ! deallocate data structure if data are not used for damping
+                  IF( .NOT.ln_trcdmp .AND. .NOT.ln_trcdmp_clo ) THEN
                      IF(lwp) WRITE(numout,*) 'trc_dta: deallocate data arrays as they are only used to initialize the run'
-                                                  DEALLOCATE( sf_trcdta(jl)%fnow )     !  arrays in the structure
+                                                  DEALLOCATE( sf_trcdta(jl)%fnow )
                      IF( sf_trcdta(jl)%ln_tint )  DEALLOCATE( sf_trcdta(jl)%fdta )
                      !
